// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "GameFramework/Actor.h"
#include "AssetStreamer.h"
#include "ImportPakFile.generated.h"

UCLASS()
class LOADTEST_API AImportPakFile : public AActor, public IAssetStreamerListener
{
	GENERATED_BODY()
	class FAssetStreamer* Streamer;
public:	
	// Sets default values for this actor's properties
	AImportPakFile();

	// Called when the game starts or when spawned
	virtual void BeginPlay() override;
	
	// Called every frame
	virtual void Tick( float DeltaSeconds ) override;

	void OnAssetStreamComplete() override;

	/** Called before the streaming is initiated, used to inform which assets will be requested */
	void OnPrepareAssetStreaming(const TArray<FStringAssetReference>& StreamedAssets) override;


	UFUNCTION(BlueprintCallable, Category = "Stream")
		void RunLoad();

	/** When a tile is touched. */
	UFUNCTION()
		void ImportPakFilePress(ETouchIndex::Type FingerIndex);

	/** When the user's finger moves over a tile. */
	UFUNCTION()
		void ImportPakFileEnter(ETouchIndex::Type FingerIndex);

	/** Mouse surrogate for TilePress. */
	UFUNCTION()
		void ImportPakFilePress_Mouse();

	/** Mouse surrogate for TileEnter. */
	UFUNCTION()
		void ImportPakFileEnter_Mouse();
};
